/***********************************************************************************************************************
MMBasic

BSDFunctions.c

Top level header file for the Maximite Computer and MMBasic
  
Copyright 2011 Geoff Graham - http://geoffg.net
This program is free software: you can redistribute it and/or modify it under the terms of the GNU General
Public License as published by the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the
implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.  You should have received a copy of the GNU General Public License along with this program.
If not, see <http://www.gnu.org/licenses/>. 

************************************************************************************************************************/
#include <string.h>
#include <ctype.h>
#include "Maximite.h"
#include "BSDFunctions.h"

int	 strcasecmp (const char *s1, const char *s2) {
	const char *p1 = s1;
	const char *p2 = s2;
	char c1;
	char c2;

	if (p1 == p2) return 0;
	do {
		c1 = tolower(*p1++);
		c2 = tolower(*p2++);
		if (c1 == '\0') break;
	} while (c1 == c2);

	return (int)(c1 - c2);
}


int	 strncasecmp (const char *s1, const char *s2, size_t n) {
	const char *p1 = s1;
	const char *p2 = s2;
	char c1;
	char c2;

	if (p1 == p2 || n == 0) return 0;
	do {
		c1 = tolower(*p1++);
		c2 = tolower(*p2++);
		if (c1 == '\0' || c1 != c2) break;
	} while (--n > 0);

	return (int)(c1 - c2);
}
